app/Http/routes.php
<?php

Route::get('/', [
    'as' => 'home',
    'uses' => 'PagesController@index'
]);

Route::get('/dashboard', [
    'as' => 'dashboard',
    'middleware' => 'auth',
    'uses' => 'DashboardController@index'
]);



Route::group(['prefix' => 'api'], function() {

    /*
     * JWT-protected Routes
    */
    Route::group(['middleware' => 'api'], function() {

        Route::get('/rate', [
            'as' => 'api.rates',
            'uses' => 'RatesController@calculate'
        ]);
        
    });

    Route::post('auth/token', 'JWTController@postToken');
    Route::get('auth/token', 'JWTController@token');

    //individual api endpoints
    Route::get('remove-country-group', [
        'as' => 'api.remove-country-group',
        'uses' => 'AdminController@removeCountryGroup'
    ]);

});

Route::group(['prefix' => 'admin', 'middleware' => 'auth'], function() {

    Route::resource('tokens', 'TokensController', ['except' => 'show']);
    Route::resource('countries', 'CountriesController', ['except' => 'show']);
    Route::resource('groups', 'GroupsController', ['except' => 'show']);
    Route::resource('rates', 'RatesController', ['only' => ['edit', 'update']]);

    //Single Routes
    Route::get('/', [
        'as' => 'admin.index',
        'uses' => 'AdminController@index'
    ]);
    Route::post('add-country-group', [
        'as' => 'admin.add-country-group',
        'uses' => 'CountryGroupController@postAdd'
    ]);

});

Route::auth();

app/Country.php
<?php

namespace App;

use App\BaseModel;

class Country extends BaseModel
{
    protected $fillable = ['area_ja', 'area_en', 'name_ja', 'name_en', 'japanese', 'iso_2', 'iso_3'];
}

app/Http/Controllers/CountriesController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Http\Requests;
use App\Country;

class CountriesController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $countries = Country::paginate(25);

        return view('admin.countries.index', [
            'countries' => $countries
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.countries.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $country = new Country();
        $validated = $country->validate($request->all());

        if ($validated->fails()) {
            return redirect()
                ->route('admin.countries.create')
                ->withInput()
                ->with('flash', [
                    'type' => 'error',
                    'message' => $validated->errors()
                ]);
        }

        $country->fill($request->all())->save();

        return redirect()
            ->route('admin.countries.index')
            ->with('flash', [
                'type' => 'success',
                'message' => trans('site.forms.messages.success')
            ]);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $country = Country::find($id);

        return view('admin.countries.edit', [
            'country' => $country
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $country = Country::find($id);
        $validated = $country->validate($request->all());

        if ($validated->fails()) {
            return redirect()
                ->route('admin.countries.edit', ['id' => $country->id])
                ->withInput()
                ->with('flash', [
                    'type' => 'error',
                    'message' => $validated->errors()
                ]);
        }

        $country->fill($request->all())->save();

        return redirect()
            ->route('admin.countries.index')
            ->with('flash', [
                'type' => 'success',
                'message' => trans('site.forms.messages.success')
            ]);

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        Country::destroy($id);
        return response()->json(1);
    }
}

resources/views/admin/countries/create.blade.php
@extends('layouts.master')

@section('title', trans('site.page_titles.admin.countries'))

@section('content')
<div class="row">
    <div class="col s6 offset-s3">
        <form method="post" action="{{ route('admin.countries.store') }}">
            <div class="row">
                <div class="col s12">
                    <h2>{{ trans('site.headers.admin.add', ['type' => 'Country']) }}</h2>
                </div>
            </div>
            <div class="row">
                <div class="col s6">
                    <div class="input-field">
                        <input type="text" name="name_en" value="{{ old('name_en') }}" id="nameEn" />
                        <label for="nameEn">{{ trans('site.forms.labels.name_en') }}</label>
                    </div>
                </div>
                <div class="col s6">
                    <div class="input-field">
                        <input type="text" name="name_ja" value="{{ old('name_ja') }}" id="nameJa" />
                        <label for="nameJa">{{ trans('site.forms.labels.name_ja') }}</label>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col s6">
                    <div class="input-field">
                        <input type="text" name="area_en" value="{{ old('area_en') }}" id="areaEn" />
                        <label for="areaEn">{{ trans('site.forms.labels.area_en') }}</label>
                    </div>
                </div>
                <div class="col s6">
                    <div class="input-field">
                        <input type="text" name="area_ja" value="{{ old('area_ja') }}" id="areaJa" />
                        <label for="areaJa">{{ trans('site.forms.labels.area_ja') }}</label>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col s12">
                    <div class="input-field">
                        <input type="text" name="iso_2" value="{{ old('iso_2') }}" id="idIso2" maxlength="2" />
                        <label for="idIso2">{{ trans('site.forms.labels.iso2') }}</label>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col s12">
                    <div class="input-field">
                        <input type="text" name="iso_3" value="{{ old('iso_3') }}" id="idIso3" maxlength="3" />
                        <label for="idIso3">{{ trans('site.forms.labels.iso2') }}</label>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col s12">
                    <div class="input-field">
                        <input type="text" name="japanese" value="{{ old('japanese') }}" id="idJapanese" />
                        <label for="idJapanese">{{ trans('site.forms.labels.japanese') }}</label>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col s12">
                    <div class="input-field">
                        {!! csrf_field() !!}
                        <button type="submit" class="waves-effect waves-light black btn">{{ trans('site.forms.actions.create_type', ['type' => 'Country']) }}</button>
                        <a href="{{ route('admin.countries.index') }}" class="waves-effect waves-teal btn-flat">{{ trans('site.actions.cancel') }}</a>
                    </div>
                </div>
            </div>
        </form>
    </div>
</div>
@endsection

resources/views/admin/countries/edit.blade.php
@extends('layouts.master')

@section('title', trans('site.page_titles.admin.countries'))

@section('content')
<div class="row">
    <div class="col s6 offset-s3">
        <form method="post" action="{{ route('admin.countries.update', ['id' => $country->id]) }}">
            <div class="row">
                <div class="col s12">
                    <h2>{{ trans('site.headers.admin.edit', ['type' => 'Country', 'id' => $country->id]) }}</h2>
                </div>
            </div>
            <div class="row">
                <div class="col s6">
                    <div class="input-field">
                        <input type="text" name="name_en" value="{{ $country->name_en }}" id="nameEn" />
                        <label for="nameEn" @if(!empty($country->name_en))class="active" @endif>{{ trans('site.forms.labels.name_en') }}</label>
                    </div>
                </div>
                <div class="col s6">
                    <div class="input-field">
                        <input type="text" name="name_ja" value="{{ $country->name_ja }}" id="nameJa" />
                        <label for="nameJa" @if(!empty($country->name_ja))class="active" @endif>{{ trans('site.forms.labels.name_ja') }}</label>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col s6">
                    <div class="input-field">
                        <input type="text" name="area_en" value="{{ $country->area_en }}" id="areaEn" />
                        <label for="areaEn" @if(!empty($country->area_en))class="active" @endif>{{ trans('site.forms.labels.area_en') }}</label>
                    </div>
                </div>
                <div class="col s6">
                    <div class="input-field">
                        <input type="text" name="area_ja" value="{{ $country->area_ja }}" id="areaJa" />
                        <label for="areaJa" @if(!empty($country->area_ja))class="active" @endif>{{ trans('site.forms.labels.area_ja') }}</label>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col s12">
                    <div class="input-field">
                        <input type="text" name="iso_2" value="{{ $country->iso_2 }}" id="idIso2" maxlength="2" />
                        <label for="idIso2" @if(!empty($country->iso_2))class="active" @endif>{{ trans('site.forms.labels.iso2') }}</label>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col s12">
                    <div class="input-field">
                        <input type="text" name="iso_3" value="{{ $country->iso_3 }}" id="idIso3" maxlength="3" />
                        <label for="idIso3" @if(!empty($country->iso_3))class="active" @endif>{{ trans('site.forms.labels.iso2') }}</label>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col s12">
                    <div class="input-field">
                        <input type="text" name="japanese" value="{{ $country->japanese }}" id="idJapanese" />
                        <label for="idJapanese" @if(!empty($country->japanese))class="active" @endif>{{ trans('site.forms.labels.japanese') }}</label>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col s12">
                    <div class="input-field">
                        {!! csrf_field() !!}
                        <input name="_method" type="hidden" value="PUT">
                        <button type="submit" class="waves-effect waves-light black btn">{{ trans('site.forms.actions.edit') }}</button>
                        <a href="{{ route('admin.countries.index') }}" class="waves-effect waves-teal btn-flat">{{ trans('site.actions.cancel') }}</a>
                    </div>
                </div>
            </div>
        </form>
    </div>
</div>
@endsection

resources/views/admin/countries/index.blade.php
@extends('layouts.master')

@section('title', trans('site.page_titles.admin.countries'))

@section('content')
<div class="container">
    @include('elements.flash')
    <h1>{{ trans('site.headers.admin.countries') }}</h1>
    <table class="striped bordered">
        <thead>
            <tr>
                <th class="id">{{ trans('site.tables.headers.id') }}</th>
                <th>{{ trans('site.tables.headers.country_name') }}</th>
                <th class="action">
                    <a href="{{ route('admin.countries.create') }}" class="btn-floating btn-small waves-effect waves-light green"><i class="material-icons">add</i>
                    </a>
                </th>
            </tr>
        </thead>
        <tbody>
            @foreach($countries as $country)
                <tr>
                    <td class="id">{{ $country->id }}</td>
                    <td>{{ $country->getField('name') }}</td>
                    <td class="action">
                        <a href="{{ route('admin.countries.destroy', ['id' => $country->id]) }}" onClick="javascript: return window.confirm('Are you sure?');" class="btn-flat waves-effect waves-light remove-resource"><i class="material-icons">delete</i></a>                
                        <a href="{{ route('admin.countries.edit', ['id' => $country->id]) }}" class="btn-floating waves-effect waves-light orange"><i class="material-icons">mode_edit</i></a>   
                    </td>            
                </tr>
            @endforeach
        </tbody>
    </table>
    <div class="text-right">
        @include('elements.pagination', ['p' => $countries])
    </div>
</div>
@endsection